# coding: utf-8

"""
    AI model Service Restful API

    This is an ai model service  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import unittest
from ai_service_python_sdk.test import host, token, appId
from ai_service_python_sdk.client.api_client import ApiClient
from ai_service_python_sdk.client.api.ai_service_llm_api import AiServiceLlmApi


class TestLLMEvalJudgerRequest(unittest.TestCase):
    """LLMEvalJudgerRequest unit test stubs"""

    def setUp(self):
        pass

    def tearDown(self):
        pass

    def testLLMEvalJudgerSingleRequest(self):
        """Test LLMEvalJudgerRequest"""
        # FIXME: construct object with mandatory attributes with example values

        api_client = ApiClient(host, appId, token)
        api = AiServiceLlmApi(api_client)

        response = api.llm_evaluation.create(
            model='Themis-1.0',
            messages=[
                {
                    "role": "user",
                    "content": [
                        {
                            "mode": "single",
                            "type": "json",
                            "json": {
                                "question": "请介绍下你自己",
                                "answer": "我是一个人工智能助手，由 OpenAI 设计并开发，旨在帮助用户解答问题、提供信息、学习语言和执行各种语言处理任务。"
                            }
                        }
                    ]
                }
            ]
        )
        print(response, response.data['choices'][0]['text'])

    def testLLMEvalJudgerPairwiseRequest(self):
        """Test LLMEvalJudgerRequest"""
        # FIXME: construct object with mandatory attributes with example values

        api_client = ApiClient(host, appId, token)
        api = AiServiceLlmApi(api_client)

        response = api.llm_evaluation.create(
            model='Themis-1.0',
            messages=[
                {
                    "role": "user",
                    "content": [
                        {
                            "mode": "single",
                            "type": "pairwise",
                            "json": {
                                "question": "请介绍下你自己",
                                "answer1": "我是一个人工智能助手，由 OpenAI 设计并开发，旨在帮助用户解答问题、提供信息、学习语言和执行各种语言处理任务。",
                                "answer2": "我是一个人工智能助手，设计用来回答问题、提供信息、助力解决问题，并在不同的领域与场景中辅助用户。",
                            }
                        }
                    ]
                }
            ]
        )
        print(response, response.data['choices'][0]['text'])

    def testLLMEvalJudgerCustomRequest(self):
        """Test LLMEvalJudgerRequest"""
        # FIXME: construct object with mandatory attributes with example values

        api_client = ApiClient(host, appId, token)
        api = AiServiceLlmApi(api_client)

        response = api.llm_evaluation.create(
            model='Themis-1.0',
            messages=[
                {"role": "system", "content": "你是一个人工智能助手"},
                {"role": "user", "content": "请介绍下你自己"}
            ]
        )
        print(response, response.data['choices'][0]['text'])


if __name__ == '__main__':
    unittest.main()

